<?php
class sv43v_application_form extends wv43v_data_form {
	public function &fields() {
		return $this->cache ( 'sv43v_application_form_fields', $this->form (), true );
	}
	public function error() {
		return $this->fields ()->error ();
	}
	public function &data() {
		return parent::data ( $this->form () );
	}
	function front_html() {
		$return = '';
		$return = $this->not_open ();
		if ($return == '') {
			if ($this->request ()->is_post () && $this->error () == 0) {
				$return = $this->process_form ();
			} else {
				if ($this->error () != 2) {
					$return = $this->entry_form ();
				} else {
					if ($this->data ()->views ['responses'] ['already_submitted'] ['show_questions'] == 1) {
						$return .= $this->entry_form ();
					}
					else
					{
						$return = $this->view->render_string ( $this->data ()->views ['responses'] ['already_submitted'] ['phtml'] );
					}
					if ($this->data ()->views ['responses'] ['already_submitted'] ['show_results'] == 1) {
						$return .= $this->do_results ();
					}
				}
			}
		}
		return $return;
	}
	protected function get_post_by_title($post_title, $output = OBJECT) {
		global $wpdb;
		$post = $wpdb->get_var ( $wpdb->prepare ( "SELECT ID FROM $wpdb->posts WHERE post_title = %s AND post_type='post'", $post_title ) );
		if ($post)
			return get_post_to_edit ( $post );
		
		return NULL;
	}
	private function not_open() {
		$status = $this->data ()->general ['status'];
		$this->view->permalink = '';
		if ($this->data ()->data_collection ['post'] ['do'] && $status == 'open') {
			if ($this->data ()->data_collection ['post'] ['name'] != '') {
				$post = $this->get_post_by_title ( $this->data ()->data_collection ['post'] ['name'] );
				if ($post) {
					$status = $post->post_status;
					switch ($status) {
						case 'pending' :
							$status = 'pending';
							break;
						case 'publish' :
							$status = 'closed';
							break;
						default :
							$status = 'open';
					}
					$this->view->permalink = get_permalink ( $post->ID );
				}
			}
		
		}
		switch ($status) {
			case 'pending' :
			case 'closed' :
				$return = $this->data ()->views ['responses'] [$status] ['phtml'];
				if ($this->data ()->data_collection ['results'] ['do'] && $this->data ()->views ['responses'] [$status] ['show_results'] == 1) {
					$return .= $this->do_results ();
				}
				break;
			default :
				$return = '';
		}
		return $return;
	}
	private function entry_form() {
		$this->view->form_fields = $this->fields ()->front_html ();
		$this->view->form_name = $this->form ();
		$this->view->form_action = get_permalink ();
		$this->view->form_error = $this->fields ()->error ();
		return trim ( $this->render_script ( 'front/form.phtml', false ), "\n\r" );
	}
	private function process_form() {
		$return = '';
		if ($this->data ()->general ['duration'] != 0) {
			$this->view->save_name = $this->application ()->slug . '_' . strtolower ( $this->form () );
			$this->view->expire = date ( 'D, d M Y H:i:0', time () + ($this->data ()->general ['duration'] * $this->data ()->general ['scale']) ) . ' UTC'; //+ (60 * 60 * 24 * 365 * 5) );
			$return .= $this->render_script ( "front/field/cookie.phtml", false );
		}
		$return .= '<div class="survey_results">';
		$return .= $this->view->render_string ( $this->data ()->views ['responses'] ['thank_you'] ['phtml'] );
		if ($this->data ()->data_collection ['email'] ['do']) {
			$return .= $this->do_email ();
		}
		if ($this->data ()->data_collection ['table'] ['do']) {
			$return .= $this->do_table ();
		}
		if ($this->data ()->data_collection ['post'] ['do']) {
			$return .= $this->do_post ();
		}
		if ($this->data ()->data_collection ['results'] ['do']) {
			$return .= $this->do_results ();
		}
		$return .= "</div>";
		return $return;
	}
	public function recipient_email() {
		$return = get_the_author_meta ( 'user_email' );
		if (! empty ( $this->data ()->data_collection ['email'] ['address'] )) {
			$return = $this->data ()->data_collection ['email'] ['address'];
		}
		return $return;
	}
	public function do_email() {
		$subject = $this->fields ()->first_field ( 'subject', get_the_title () );
		$website = $this->fields ()->first_field ( 'website' );
		$recipient = $this->recipient_email ();
		$mail = new wv43v_mail ( false );
		$message = $this->fields ()->email_txt ();
		foreach ( $this->fields ()->email_details () as $email ) {
			$from = $email->name ['value'] . " <" . $email->email ['value'] . ">";
			$mail->send ( $this->recipient_email (), $subject, $message, $from );
			break;
		}
		foreach ( $this->fields ()->email_details () as $email ) {
			if ($email->cc) {
				$from = $email->name ['value'] . " <" . $email->email ['value'] . ">";
				$mail->send ( $email->email ['value'], $subject, $message, $from );
			}
		}
		return '';
	}
	public function do_post() {
		$post = '';
		$sender = null;
		foreach ( $this->fields ()->email_details () as $sender ) {
			$post .= 'Submitted by ' . $sender->name ['value'] . '<br/>';
			break;
		}
		$post .= $this->fields ()->post_html ();
		$newpost = null;
		if (isset ( $this->data ()->data_collection ['post'] ['name'] )) {
			$newpost = get_page_by_title ( $this->data ()->data_collection ['post'] ['name'], OBJECT, 'post' );
		}
		if (is_null ( $newpost )) {
			$newpost = get_default_post_to_edit ();
			$newpost->post_content = '<ul class="submit"></ul>';
		}
		// remove get old submissions from post without ul tags
		$pattern = '|<ul class="submit">([\w\W\s\S]*)</ul>|Ui';
		preg_match_all ( $pattern, $newpost->post_content, $matches, PREG_SET_ORDER );
		$old_content = "";
		foreach ( $matches as $match ) {
			$old_content = $match [1];
			break;
		}
		$newpost->post_title = $this->data ()->data_collection ['post'] ['name'];
		$newpost->post_author = get_the_author_meta ( 'ID' );
		$newpost->post_content = '<ul class="submit">' . $old_content . '<li>' . $post . '</li></ul>';
		$id = wp_update_post ( $newpost );
		
		if (null !== $sender) {
			add_post_meta ( $id, $sender->name ['value'], $sender->email ['value'], false );
		}
		return '';
	}
	public function do_results() {
		$post = '';
		$post .= $this->fields ()->results_html ();
		return $post;
	}
	public function do_table() {
		$data = $this->fields ()->table_data ();
		$table = strtolower ( $this->application ()->slug . '_' . strtolower ( $this->form () ) );
		$this->create ( $data, $table );
		return '';
	}
	public function create($fields, $table) {
		$newfields = array ();
		foreach ( $fields as $key => $value ) {
			if (is_array ( $value )) {
				foreach ( $value as $key2 => $value2 ) {
					$newfields [urldecode ( $key ) . '[' . urldecode ( $key2 ) . ']'] = $value2;
				}
			} else {
				$newfields [urldecode ( $key )] = $value;
			}
		}
		$fields = $newfields;
		$newfields = null;
		$this->fields = array ('id' => array ('type' => 'bigint(20)', 'null' => false, 'extra' => 'AUTO_INCREMENT' ) );
		$this->keys = array ('primary' => 'id' );
		$this->table ( $table )->create_table ( $this->fields, $this->keys );
		$results = $this->table ( $table )->show_columns ();
		$columns = array ();
		foreach ( $results as $result ) {
			$columns [] = $result ['Field'];
		}
		foreach ( $fields as $key => $value ) {
			$key = trim ( $key, "`" );
			if (! in_array ( $key, $columns ) && $key != '') {
				$type = 'text';
				switch ($key) {
					case 'info[form_sent]' :
					case 'info[form_received]' :
						$type = 'datetime';
						break;
					case 'info[submission]' :
					case 'info[wp_user]' :
					case 'info[quiz_questions]' :
					case 'info[quiz_score]' :
						$type = 'bigint(20)';
				}
				$this->table ( $table )->alter_table ( $key, $type );
			}
		}
		$sender = null;
		foreach ( $this->fields ()->email_details () as $sender ) {
			break;
		}
		$where = '';
		if (null !== $sender) {
			$where = " `%s` = '%s' OR ";
			$this->table ()->field_name ( $sender->email ['question'] );
			$where = sprintf ( $where, $sender->email ['question'], $sender->email ['value'] );
		}
		$sql = 'SELECT count(*)+1 \'count\' FROM `%s` WHERE %s (`info[wp_user]`=%d AND `info[wp_user]`!=-1)';
		$sql = sprintf ( $sql, $this->table ( $table )->name (), $where, $fields ['info[wp_user]'] );
		foreach ( $this->table ( $table )->execute ( $sql ) as $submission ) {
			$fields ['info[submission]'] = $submission ['count'];
		}
		$this->table ( $table )->insert ( $fields );
	}
	function admin_html() {
		return $this->view->form_fields = $this->fields ()->admin_html ();
	}

}