<?php
class survey_rewrite extends wv43v_action {
	public function sandboxWPpageMeta($return) {
		$return ['slug'] = $this->application ()->slug;
		return $return;
	}
	public function sandboxWPpage($subpage) {
		$return = false;
		if (count ( $subpage ) == 2) {
			$forms = $this->form ()->forms ();
			$pi = pathinfo ( $subpage [0] );
			$form = $pi ['filename'];
			$pi = pathinfo ( $subpage [1] );
			$switch = $pi ['filename'];
			$ext = '';
			if (isset ( $pi ['extension'] )) {
				$ext = $pi ['extension'];
			}
			if (isset ( $forms [$form] )) {
				switch ($ext) {
					case 'png' :
						$return = $this->png ( $form, $switch );
						break;
					case 'csv' :
						$return = $this->csv ( $form, $switch );
						break;
				}
			}
		}
		return $return;
	}
	private function png($form, $switch) {
		$return = false;
		$polls = $this->form ( $form )->fields ()->poll_details ();
		if (isset ( $polls [$switch - 1] )) {
			$poll = $polls [$switch - 1]->poll_question ['details'];
			$graphics = $this->data ( $form )->graphics;
			$return = true;
			$sql = "SELECT `%s` as 'option',count(*) as 'count' from `%s` WHERE `info[submission]` is null or `info[submission]` = 1 GROUP BY `%s` ORDER BY `%s` DESC;";
			$table = $this->application ()->slug . '_' . $form;
			$sql = sprintf ( $sql, $poll ['question'], $this->table ( $table )->name (), $poll ['question'], $poll ['question'] );
			$data = $this->table ()->execute ( $sql );
			$max = 0;
			foreach ( $data as $datum ) {
				$max = $datum ['count'];
				break;
			}
			$options = $poll ['options'];
			$options = array_flip ( $options );
			foreach ( $options as &$option ) {
				$option = 0;
			}
			unset ( $option );
			foreach ( $data as $datum ) {
				$options [$datum ['option']] = $datum ['count'];
			}
			$sum = array_sum ( $options );
			$values = $options;
			$labels = implode ( '|', array_reverse ( array_keys ( $options ) ) );
			$labels = array_keys ( $options );
			$name = $poll ['question'];
			$height = ((count ( $options )) * 24) + 60;
			$qs = array ();
			$qs ['cht'] = $graphics ['type']; // chart type.
			//$qs ['cht'] = 'bhs'; // chart type.
			//$qs ['cht'] = 'bvs'; // chart type.
			//$qs ['cht'] = 'p3'; // chart type.
			//$qs ['cht'] = 'p'; // chart type.
			switch ($qs ['cht']) {
				case 'bhs' :
				case 'bvs' :
					$qs ['chbh'] = 'a'; // width , bar seperation, group speration
					switch ($qs ['cht']) {
						case 'bhs' :
							$qs ['chxt'] = "y,x"; // char axis
							$qs ['chxl'] = "0:|" . implode ( '|', array_reverse ( $labels ) ) . "|1:|{$sum} Votes"; // chart axis labels
							break;
						case 'bvs' :
							$qs ['chxt'] = "x,x"; // char axis
							$qs ['chxl'] = "0:|" . implode ( '|', array_reverse ( $labels ) ) . "|1:|{$sum} Votes"; // chart axis labels
							break;
					}
					$qs ['chm'] = "N*p0*,000000,0,,11,,e"; // not sure displays %age though
					$qs ['chxp'] = "1,50"; // chart axis postistion
					$qs ['chxr'] = "0,0,{$max}"; // chart axis range
					$qs ['chxs'] = "1,676767,11.5,0,_,676767"; //turn of x axis
					$values = $this->percent ( $values, 1, '' );
					$qs ['chds'] = "0," . max ( $values ); // chart data scale
					break;
				case 'p' :
				case 'p3' :
					$name .= ' (' . array_sum ( $values ) . ' Votes)';
					$qs ['chdl'] = implode ( '|', $this->percent ( $values ) ); // chart data
					$qs ['chl'] = implode ( '|', $labels ); // chart data
					$qs ['chxt'] = "x"; // char axis
					break;
			}
			$qs ['chtt'] = "{$name}"; // chart name
			$qs ['chd'] = "t:" . implode ( ',', $values ); // chart data
			$qs ['chco'] = str_replace ( "\n", '|', $graphics ['colors'] );
			$qs ['chs'] = $graphics ['width'] . "x{$height}"; // chart size
			$http = new bv43v_http ( 'http://chart.apis.google.com/chart' );
			$http->method ( 'POST' );
			$http->data ( $qs );
			$http->display ();
		}
		return $return;
	}
	private function csv($form, $switch) {
		$return = false;
		$where = '';
		switch ($switch) {
			case 'all' :
				$return = true;
				break;
		}
		if ($return) {
			$this->send_headers ( "{$form}.csv" );
			//$this->send_headers ( ".txt" );
			$sql = 'SELECT * from `%s`;';
			$table = $this->application ()->slug . '_' . $form;
			$sql = sprintf ( $sql, $this->table ( $table )->name () );
			$data = $this->table ()->execute ( $sql );
			if (count ( $data ) > 0) {
				echo '"' . implode ( '","', array_keys ( $data [0] ) ) . '"' . "\n";
			}
			foreach ( $data as $datum ) {
				foreach ( $datum as &$value ) {
					$value = stripslashes ( $value );
					$value = str_replace ( '"', '""', $value );
				}
				unset ( $value );
				echo '"' . implode ( '","', $datum ) . '"' . "\n";
			}
		}
		return $return;
	}
	private function percent($array, $scale = 100, $suffix = '%') {
		$sum = array_sum ( $array );
		foreach ( $array as $key => $value ) {
			if ($sum == 0) {
				$array [$key] = '0' . $suffix;
			} else {
				if ($scale == 1) {
					$array [$key] = (($value / $sum) * $scale) . $suffix;
				} else {
					$array [$key] = round ( ($value / $sum) * $scale, 0, PHP_ROUND_HALF_UP ) . $suffix;
				}
			}
		}
		return $array;
	}
	protected function get_path($root = '') {
		$page = strtolower ( $_SERVER ['HTTP_HOST'] . $_SERVER ['REQUEST_URI'] );
		$rootlen = strlen ( str_replace ( 'http://', '', $root ) );
		$page = trim ( substr ( $page, $rootlen ), '/' );
		$pages = explode ( '/', $page );
		return $pages;
	}
}